# 工作流系统使用的链交互程序

简明流程:

1. 使用企业微信的审判功能作为工作流
2. 审判通过后, 获取审批表单信息和附件, 处理后入库
3. 根据不同的操作生成对应操作的 abi, 添加到多签钱包的 schedule
4. 发送邮件给确认者
5. 收到 ScheduleConfirm 事件后, 上链执行对应的 schedule
6. 执行结束后, 调用企业微信的 `发起审批` 流程, 通知申请人

系统时序图:

```mermaid
%% NFT资产管理时序图
sequenceDiagram
participant user
participant qywx
participant chain_client
participant admin
participant chain_wallet

user->>qywx: 发起审批流程
loop 审批流程
qywx->qywx: 审核
end
qywx->>chain_client: 审批通过后通知到链客户端
chain_client->>chain_wallet: 根据规则发起一系列的schedule
chain_client->>admin: 发送邮件通知拥有确认权限的人
admin->>chain_wallet: 确认schedule
chain_wallet-->>chain_client: 通知已确认
chain_client->>chain_wallet: 执行对应的schedule
chain_client->>qywx: 发起通知的审批流程
qywx->>user: 通知申请人, 整个流程结果
```
