import { Severity, getModelForClass, index, modelOptions, mongoose, prop } from '@typegoose/typegoose'
import { dbconn } from 'decorators/dbconn'
import { BaseModule } from './Base'

@dbconn()
@index({ hash: 1 }, { unique: true })
@modelOptions({
  schemaOptions: { collection: 'block_data', timestamps: true },
  options: { allowMixed: Severity.ALLOW },
})
export class BlockDataClass extends BaseModule {
  @prop({ required: true })
  public hash!: string
  @prop()
  public chainId: number

  @prop({ type: mongoose.Schema.Types.Mixed })
  public data: any

  public static async saveBlock(event: any) {
    return BlockData.insertOrUpdate({ hash: event.hash }, { data: event })
  }
}

export const BlockData = getModelForClass(BlockDataClass, {
  existingConnection: BlockDataClass['db'],
})
