import { CheckIn } from "./CheckIn"
import { ChestRecord } from "./ChestRecord"
import { GeneralScription } from "./GeneralScription"
import Web3 from 'web3'

const ops = {
  '1': 'check',
  '2': 'explore',
  '3': 'chest_enhance',
  '4': 'chest_open',
  '5': 'task_claim'
}

const nexts = {
  '1': CheckIn,
  '2': GeneralScription,
  '3': GeneralScription,
  '4': ChestRecord,
  '5': GeneralScription
}

const inputs = {
  '1': 'data:,{"p":"cf-20","op":"check"}',
  '2': 'data:,{"p":"cf-20","op":"explore","val":"${val}"}',
  '3': 'data:,{"p":"cf-20","op":"chest_enhance","val":"${val}"}',
  '4': 'data:,{"p":"cf-20","op":"chest_open","id":"${val}',
  '5': 'data:,{"p":"cf-20","op":"task_claim","val":"${val}"}'
}
export class TreasureHunt {
  public static async parseEvent(event: any) {
    const hash = event.hash || event.transactionHash
    let {user, action, value} = event.decodedData

    let eventScription = {
      hash,
      "blockHash" : event.blockHash,
      "blockNumber" : event.blockNumber,
      "blockTime" : event.blockTime,
      "from" : user,
      "input" : "",
      "op" : ops[action],
      "to" : event.address,
      "value" : "0x0"
    }
    if (action === '2' || action === '5') {
      let val = Web3.utils.numberToHex(value).replace('0x', '')
      // convert value from hex to base64
      val = Buffer.from(val, 'hex').toString()
      eventScription.input = inputs[action].replace('${val}', val)
    } else if (action === '3' || action === '4') {
      let val = Web3.utils.numberToHex(value).replace('0x', '')
      eventScription.input = inputs[action].replace('${val}', val)
    } else {
      eventScription.input = inputs[action]
    }
    await nexts[action].saveEvent(eventScription)
  }
}